import translate.*;

import java.io.*;
import java.util.*;

public class Test {

        public static void main(String[] args) throws Exception {
                if (args.length != 4) {
                        System.err.println("Usage: java Test <gfc grammar> <cfg grammar> <input language> <output language>");
                        System.exit(1);
                }
                        

                String gfcFile = args[0];
                String cfgFile = args[1];
                String inputLang = args[2];
                String outputLang = args[3];

                Translator t = TranslatorFactory.createTranslator(cfgFile, gfcFile, 
                                                                  new String[]{ "parse.ParseTree" },
                                                                  new String[] { "linearize.LinearizeTree" } );

                BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
                String line;
                while ((line = in.readLine()) != null) {
                        Set<String> ts = t.translate(inputLang, outputLang, line);
                        if (ts.size() == 0) {
                                System.out.println("<no translation>");
                        } else if (ts.size() == 1) {
                                String s = ts.iterator().next();
                                System.out.println(s);
                        } else {
                                System.out.println("<Ambiguous translation:>");
                                for (String s : ts) {
                                        System.out.println(s);
                                }
                        }
                }
        }

/*
        public static void saveGrammar(String file, Map<String,LinRules> modules) throws IOException {
                ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream(file));
                out.writeObject(modules);
                out.close();
        }

        public static Map<String,LinRules> loadGrammar(String file) 
                throws IOException, ClassNotFoundException {

                ObjectInputStream in = new ObjectInputStream(new FileInputStream(file));
                Map<String,LinRules> grammar = (Map<String,LinRules>)in.readObject();
                in.close();
                return grammar;
        }
*/
}
