package abssyn;

import SyntaxTree.*;
import SyntaxTree.Absyn.*;

public class GFTreeToTree implements Tr.Visitor<Tree,Integer>
{

        public static Tree toTree(Tr t) {
                return t.accept(new GFTreeToTree(), 0);
        }
        
        public Tree visit(SyntaxTree.Absyn.TNode tnode, Integer arg) {
                Fun t = new Fun(tnode.ident_, tnode.listtr_.size());
                int i = 0;
                for (Tr c : tnode.listtr_)
                        t.setChild(i++, c.accept(this, arg));
                return t;
        }

        public Tree visit(SyntaxTree.Absyn.TAtom tatom, Integer arg) {
                return new Fun(tatom.ident_, 0);
        }

        public Tree visit(SyntaxTree.Absyn.TStr tstr, Integer arg) {
                return new Literal(tstr.string_);
        }

        public Tree visit(SyntaxTree.Absyn.TInt tint, Integer arg) {
                return new Literal(String.valueOf(tint.integer_));
        }

}
