package CFG;
import CFG.Absyn.*;

import java.util.*; // HACKED

public class PrettyPrinter
{
  //For certain applications increasing the initial size of the buffer may improve performance.
  private static final int INITIAL_BUFFER_SIZE = 128;
  //You may wish to change the parentheses used in precedence.
  private static final String _L_PAREN = new String("(");
  private static final String _R_PAREN = new String(")");

        // HACKED SECTION

        // FIXME: does not print rules on separate lines.

        private static Set<String> nonSpace;

        static {
                nonSpace = new HashSet<String>();
                nonSpace.addAll(Arrays.asList("[","]","{","}",",","/",":",".","!","=",";"));
        }

        private static void render(String s) {

                if (s.equals("")) {
                        return;
                } else if (s.equals(".")) {
                        int last = buf_.length()-1;
                        buf_.append(s);
                        if (buf_.charAt(last) == ']')
                                buf_.append(' ');
                } else if (nonSpace.contains(s)) {
                        int last = buf_.length()-1;
                        if (buf_.charAt(last) == ' ')
                                buf_.deleteCharAt(last);
                        buf_.append(s);
                } else {
                        buf_.append(s);
                        buf_.append(' ');
                }
        }

        // END HACKED SECTION

  //  print and show methods are defined for each category.
  public static String print(CFG.Absyn.Grammars foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.Grammars foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.Grammar foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.Grammar foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.ListGrammar foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.ListGrammar foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.Flag foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.Flag foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.ListFlag foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.ListFlag foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.Rule foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.Rule foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.ListRule foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.ListRule foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.Profile foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.Profile foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.Ints foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.Ints foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.ListInts foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.ListInts foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.ListInteger foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.ListInteger foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.Symbol foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.Symbol foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.ListSymbol foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.ListSymbol foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.Name foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.Name foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.ListIdentParam foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.ListIdentParam foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.Category foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.Category foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.IdentParam foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.IdentParam foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.Field foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.Field foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.ListField foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.ListField foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.Proj foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.Proj foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.ListProj foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.ListProj foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.KeyValue foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.KeyValue foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.ListKeyValue foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.ListKeyValue foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.Param foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.Param foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.ListParam foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.ListParam foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  /***   You shouldn't need to change anything beyond this point.   ***/

  private static void pp(CFG.Absyn.Grammars foo, int _i_)
  {
    if (foo instanceof CFG.Absyn.Grammars)
    {
       CFG.Absyn.Grammars _grammars = (CFG.Absyn.Grammars) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_grammars.listgrammar_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(CFG.Absyn.Grammar foo, int _i_)
  {
    if (foo instanceof CFG.Absyn.Grammar)
    {
       CFG.Absyn.Grammar _grammar = (CFG.Absyn.Grammar) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("grammar");
       pp(_grammar.ident_, 0);
       pp(_grammar.listflag_, 0);
       pp(_grammar.listrule_, 0);
       render("end");
       render("grammar");
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(CFG.Absyn.ListGrammar foo, int _i_)
  {
     for (java.util.Iterator<Grammar> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render("");
       } else {
         render("");
       }
     }
  }

  private static void pp(CFG.Absyn.Flag foo, int _i_)
  {
    if (foo instanceof CFG.Absyn.StartCat)
    {
       CFG.Absyn.StartCat _startcat = (CFG.Absyn.StartCat) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("startcat");
       pp(_startcat.category_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(CFG.Absyn.ListFlag foo, int _i_)
  {
     for (java.util.Iterator<Flag> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render(";");
       } else {
         render(";");
       }
     }
  }

  private static void pp(CFG.Absyn.Rule foo, int _i_)
  {
    if (foo instanceof CFG.Absyn.Rule)
    {
       CFG.Absyn.Rule _rule = (CFG.Absyn.Rule) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_rule.ident_, 0);
       render(":");
       pp(_rule.name_, 0);
       pp(_rule.profile_, 0);
       render(".");
       pp(_rule.category_, 0);
       render("->");
       pp(_rule.listsymbol_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(CFG.Absyn.ListRule foo, int _i_)
  {
     for (java.util.Iterator<Rule> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render(";");
       } else {
         render(";");
       }
     }
  }

  private static void pp(CFG.Absyn.Profile foo, int _i_)
  {
    if (foo instanceof CFG.Absyn.Profile)
    {
       CFG.Absyn.Profile _profile = (CFG.Absyn.Profile) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("[");
       pp(_profile.listints_, 0);
       render("]");
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(CFG.Absyn.Ints foo, int _i_)
  {
    if (foo instanceof CFG.Absyn.Ints)
    {
       CFG.Absyn.Ints _ints = (CFG.Absyn.Ints) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("[");
       pp(_ints.listinteger_, 0);
       render("]");
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(CFG.Absyn.ListInts foo, int _i_)
  {
     for (java.util.Iterator<Ints> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render(",");
       } else {
         render("");
       }
     }
  }

  private static void pp(CFG.Absyn.ListInteger foo, int _i_)
  {
     for (java.util.Iterator<Integer> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render(",");
       } else {
         render("");
       }
     }
  }

  private static void pp(CFG.Absyn.Symbol foo, int _i_)
  {
    if (foo instanceof CFG.Absyn.CatS)
    {
       CFG.Absyn.CatS _cats = (CFG.Absyn.CatS) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_cats.category_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof CFG.Absyn.TermS)
    {
       CFG.Absyn.TermS _terms = (CFG.Absyn.TermS) foo;
       if (_i_ > 0) render(_L_PAREN);
       printQuoted(_terms.string_);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(CFG.Absyn.ListSymbol foo, int _i_)
  {
     for (java.util.Iterator<Symbol> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render("");
       } else {
         render("");
       }
     }
  }

  private static void pp(CFG.Absyn.Name foo, int _i_)
  {
    if (foo instanceof CFG.Absyn.Name)
    {
       CFG.Absyn.Name _name = (CFG.Absyn.Name) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_name.listidentparam_, 0);
       pp(_name.category_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(CFG.Absyn.ListIdentParam foo, int _i_)
  {
     for (java.util.Iterator<IdentParam> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render("/");
       } else {
         render("/");
       }
     }
  }

  private static void pp(CFG.Absyn.Category foo, int _i_)
  {
    if (foo instanceof CFG.Absyn.Category)
    {
       CFG.Absyn.Category _category = (CFG.Absyn.Category) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_category.identparam_, 0);
       render(".");
       pp(_category.ident_, 0);
       pp(_category.listproj_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(CFG.Absyn.IdentParam foo, int _i_)
  {
    if (foo instanceof CFG.Absyn.IdentParam)
    {
       CFG.Absyn.IdentParam _identparam = (CFG.Absyn.IdentParam) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_identparam.ident_, 0);
       render("{");
       pp(_identparam.listfield_, 0);
       render("}");
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(CFG.Absyn.Field foo, int _i_)
  {
    if (foo instanceof CFG.Absyn.Field)
    {
       CFG.Absyn.Field _field = (CFG.Absyn.Field) foo;
       if (_i_ > 0) render(_L_PAREN);
       render(".");
       pp(_field.keyvalue_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(CFG.Absyn.ListField foo, int _i_)
  {
     for (java.util.Iterator<Field> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render(";");
       } else {
         render(";");
       }
     }
  }

  private static void pp(CFG.Absyn.Proj foo, int _i_)
  {
    if (foo instanceof CFG.Absyn.Proj)
    {
       CFG.Absyn.Proj _proj = (CFG.Absyn.Proj) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("!");
       pp(_proj.param_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(CFG.Absyn.ListProj foo, int _i_)
  {
     for (java.util.Iterator<Proj> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render("");
       } else {
         render("");
       }
     }
  }

  private static void pp(CFG.Absyn.KeyValue foo, int _i_)
  {
    if (foo instanceof CFG.Absyn.KeyValue)
    {
       CFG.Absyn.KeyValue _keyvalue = (CFG.Absyn.KeyValue) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_keyvalue.ident_, 0);
       render("=");
       pp(_keyvalue.param_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(CFG.Absyn.ListKeyValue foo, int _i_)
  {
     for (java.util.Iterator<KeyValue> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render(";");
       } else {
         render("");
       }
     }
  }

  private static void pp(CFG.Absyn.Param foo, int _i_)
  {
    if (foo instanceof CFG.Absyn.ParamSimple)
    {
       CFG.Absyn.ParamSimple _paramsimple = (CFG.Absyn.ParamSimple) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_paramsimple.ident_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof CFG.Absyn.ParamPatt)
    {
       CFG.Absyn.ParamPatt _parampatt = (CFG.Absyn.ParamPatt) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_parampatt.ident_1, 0);
       render("(");
       pp(_parampatt.ident_2, 0);
       render(")");
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof CFG.Absyn.ParamRec)
    {
       CFG.Absyn.ParamRec _paramrec = (CFG.Absyn.ParamRec) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("{");
       pp(_paramrec.listkeyvalue_, 0);
       render("}");
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(CFG.Absyn.ListParam foo, int _i_)
  {
     for (java.util.Iterator<Param> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render("");
       } else {
         render("");
       }
     }
  }


  private static void sh(CFG.Absyn.Grammars foo)
  {
    if (foo instanceof CFG.Absyn.Grammars)
    {
       CFG.Absyn.Grammars _grammars = (CFG.Absyn.Grammars) foo;
       render("(");
       render("Grammars");
       render("[");
       sh(_grammars.listgrammar_);
       render("]");
       render(")");
    }
  }

  private static void sh(CFG.Absyn.Grammar foo)
  {
    if (foo instanceof CFG.Absyn.Grammar)
    {
       CFG.Absyn.Grammar _grammar = (CFG.Absyn.Grammar) foo;
       render("(");
       render("Grammar");
       sh(_grammar.ident_);
       render("[");
       sh(_grammar.listflag_);
       render("]");
       render("[");
       sh(_grammar.listrule_);
       render("]");
       render(")");
    }
  }

  private static void sh(CFG.Absyn.ListGrammar foo)
  {
     for (java.util.Iterator<Grammar> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(CFG.Absyn.Flag foo)
  {
    if (foo instanceof CFG.Absyn.StartCat)
    {
       CFG.Absyn.StartCat _startcat = (CFG.Absyn.StartCat) foo;
       render("(");
       render("StartCat");
       sh(_startcat.category_);
       render(")");
    }
  }

  private static void sh(CFG.Absyn.ListFlag foo)
  {
     for (java.util.Iterator<Flag> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(CFG.Absyn.Rule foo)
  {
    if (foo instanceof CFG.Absyn.Rule)
    {
       CFG.Absyn.Rule _rule = (CFG.Absyn.Rule) foo;
       render("(");
       render("Rule");
       sh(_rule.ident_);
       sh(_rule.name_);
       sh(_rule.profile_);
       sh(_rule.category_);
       render("[");
       sh(_rule.listsymbol_);
       render("]");
       render(")");
    }
  }

  private static void sh(CFG.Absyn.ListRule foo)
  {
     for (java.util.Iterator<Rule> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(CFG.Absyn.Profile foo)
  {
    if (foo instanceof CFG.Absyn.Profile)
    {
       CFG.Absyn.Profile _profile = (CFG.Absyn.Profile) foo;
       render("(");
       render("Profile");
       render("[");
       sh(_profile.listints_);
       render("]");
       render(")");
    }
  }

  private static void sh(CFG.Absyn.Ints foo)
  {
    if (foo instanceof CFG.Absyn.Ints)
    {
       CFG.Absyn.Ints _ints = (CFG.Absyn.Ints) foo;
       render("(");
       render("Ints");
       render("[");
       sh(_ints.listinteger_);
       render("]");
       render(")");
    }
  }

  private static void sh(CFG.Absyn.ListInts foo)
  {
     for (java.util.Iterator<Ints> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(CFG.Absyn.ListInteger foo)
  {
     for (java.util.Iterator<Integer> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(CFG.Absyn.Symbol foo)
  {
    if (foo instanceof CFG.Absyn.CatS)
    {
       CFG.Absyn.CatS _cats = (CFG.Absyn.CatS) foo;
       render("(");
       render("CatS");
       sh(_cats.category_);
       render(")");
    }
    if (foo instanceof CFG.Absyn.TermS)
    {
       CFG.Absyn.TermS _terms = (CFG.Absyn.TermS) foo;
       render("(");
       render("TermS");
       sh(_terms.string_);
       render(")");
    }
  }

  private static void sh(CFG.Absyn.ListSymbol foo)
  {
     for (java.util.Iterator<Symbol> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(CFG.Absyn.Name foo)
  {
    if (foo instanceof CFG.Absyn.Name)
    {
       CFG.Absyn.Name _name = (CFG.Absyn.Name) foo;
       render("(");
       render("Name");
       render("[");
       sh(_name.listidentparam_);
       render("]");
       sh(_name.category_);
       render(")");
    }
  }

  private static void sh(CFG.Absyn.ListIdentParam foo)
  {
     for (java.util.Iterator<IdentParam> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(CFG.Absyn.Category foo)
  {
    if (foo instanceof CFG.Absyn.Category)
    {
       CFG.Absyn.Category _category = (CFG.Absyn.Category) foo;
       render("(");
       render("Category");
       sh(_category.identparam_);
       sh(_category.ident_);
       render("[");
       sh(_category.listproj_);
       render("]");
       render(")");
    }
  }

  private static void sh(CFG.Absyn.IdentParam foo)
  {
    if (foo instanceof CFG.Absyn.IdentParam)
    {
       CFG.Absyn.IdentParam _identparam = (CFG.Absyn.IdentParam) foo;
       render("(");
       render("IdentParam");
       sh(_identparam.ident_);
       render("[");
       sh(_identparam.listfield_);
       render("]");
       render(")");
    }
  }

  private static void sh(CFG.Absyn.Field foo)
  {
    if (foo instanceof CFG.Absyn.Field)
    {
       CFG.Absyn.Field _field = (CFG.Absyn.Field) foo;
       render("(");
       render("Field");
       sh(_field.keyvalue_);
       render(")");
    }
  }

  private static void sh(CFG.Absyn.ListField foo)
  {
     for (java.util.Iterator<Field> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(CFG.Absyn.Proj foo)
  {
    if (foo instanceof CFG.Absyn.Proj)
    {
       CFG.Absyn.Proj _proj = (CFG.Absyn.Proj) foo;
       render("(");
       render("Proj");
       sh(_proj.param_);
       render(")");
    }
  }

  private static void sh(CFG.Absyn.ListProj foo)
  {
     for (java.util.Iterator<Proj> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(CFG.Absyn.KeyValue foo)
  {
    if (foo instanceof CFG.Absyn.KeyValue)
    {
       CFG.Absyn.KeyValue _keyvalue = (CFG.Absyn.KeyValue) foo;
       render("(");
       render("KeyValue");
       sh(_keyvalue.ident_);
       sh(_keyvalue.param_);
       render(")");
    }
  }

  private static void sh(CFG.Absyn.ListKeyValue foo)
  {
     for (java.util.Iterator<KeyValue> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(CFG.Absyn.Param foo)
  {
    if (foo instanceof CFG.Absyn.ParamSimple)
    {
       CFG.Absyn.ParamSimple _paramsimple = (CFG.Absyn.ParamSimple) foo;
       render("(");
       render("ParamSimple");
       sh(_paramsimple.ident_);
       render(")");
    }
    if (foo instanceof CFG.Absyn.ParamPatt)
    {
       CFG.Absyn.ParamPatt _parampatt = (CFG.Absyn.ParamPatt) foo;
       render("(");
       render("ParamPatt");
       sh(_parampatt.ident_1);
       sh(_parampatt.ident_2);
       render(")");
    }
    if (foo instanceof CFG.Absyn.ParamRec)
    {
       CFG.Absyn.ParamRec _paramrec = (CFG.Absyn.ParamRec) foo;
       render("(");
       render("ParamRec");
       render("[");
       sh(_paramrec.listkeyvalue_);
       render("]");
       render(")");
    }
  }

  private static void sh(CFG.Absyn.ListParam foo)
  {
     for (java.util.Iterator<Param> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }


  private static void pp(Integer n, int _i_) { buf_.append(n); buf_.append(" "); }
  private static void pp(Double d, int _i_) { buf_.append(d); buf_.append(" "); }
  private static void pp(String s, int _i_) { buf_.append(s); buf_.append(" "); }
  private static void pp(Character c, int _i_) { buf_.append("'" + c.toString() + "'"); buf_.append(" "); }
  private static void sh(Integer n) { render(n.toString()); }
  private static void sh(Double d) { render(d.toString()); }
  private static void sh(Character c) { render(c.toString()); }
  private static void sh(String s) { printQuoted(s); }
  private static void printQuoted(String s) { render("\"" + s + "\""); }
  private static void indent()
  {
    int n = _n_;
    while (n > 0)
    {
      buf_.append(" ");
      n--;
    }
  }
  private static void backup()
  {
   String s = buf_.toString();

     if (s.substring(buf_.length() - 1, buf_.length()).equals(" ")) {
       buf_.setCharAt(buf_.length() - 1, '\"');
       buf_.setLength(buf_.length() - 1);
     }
  }
  private static void trim()
  {
     while (buf_.length() > 0 && buf_.charAt(0) == ' ')
        buf_.deleteCharAt(0); 
    while (buf_.length() > 0 && buf_.charAt(buf_.length()-1) == ' ')
        buf_.deleteCharAt(buf_.length()-1);
  }
  private static int _n_ = 0;
  private static StringBuilder buf_ = new StringBuilder(INITIAL_BUFFER_SIZE);
}

