package CFG;
import CFG.Absyn.*;
/*** BNFC-Generated Visitor Design Pattern Skeleton. ***/
/* This implements the common visitor design pattern.
   Tests show it to be slightly less efficient than the
   instanceof method, but easier to use. 
   Replace the R and A parameters with the desired return
   and context types.*/

public class VisitSkel
{
  public class GrammarsVisitor<R,A> implements Grammars.Visitor<R,A>
  {
    public R visit(CFG.Absyn.Grammars p, A arg)
    {
      /* Code For Grammars Goes Here */

      for (Grammar x : p.listgrammar_) {
      }

      return null;
    }

  }
  public class GrammarVisitor<R,A> implements Grammar.Visitor<R,A>
  {
    public R visit(CFG.Absyn.Grammar p, A arg)
    {
      /* Code For Grammar Goes Here */

      //p.ident_;
      for (Flag x : p.listflag_) {
      }
      for (Rule x : p.listrule_) {
      }

      return null;
    }

  }
  public class FlagVisitor<R,A> implements Flag.Visitor<R,A>
  {
    public R visit(CFG.Absyn.StartCat p, A arg)
    {
      /* Code For StartCat Goes Here */

      p.category_.accept(new CategoryVisitor<R,A>(), arg);

      return null;
    }

  }
  public class RuleVisitor<R,A> implements Rule.Visitor<R,A>
  {
    public R visit(CFG.Absyn.Rule p, A arg)
    {
      /* Code For Rule Goes Here */

      //p.ident_;
      p.name_.accept(new NameVisitor<R,A>(), arg);
      p.profile_.accept(new ProfileVisitor<R,A>(), arg);
      p.category_.accept(new CategoryVisitor<R,A>(), arg);
      for (Symbol x : p.listsymbol_) {
      }

      return null;
    }

  }
  public class ProfileVisitor<R,A> implements Profile.Visitor<R,A>
  {
    public R visit(CFG.Absyn.Profile p, A arg)
    {
      /* Code For Profile Goes Here */

      for (Ints x : p.listints_) {
      }

      return null;
    }

  }
  public class IntsVisitor<R,A> implements Ints.Visitor<R,A>
  {
    public R visit(CFG.Absyn.Ints p, A arg)
    {
      /* Code For Ints Goes Here */

      for (Integer x : p.listinteger_) {
      }

      return null;
    }

  }
  public class SymbolVisitor<R,A> implements Symbol.Visitor<R,A>
  {
    public R visit(CFG.Absyn.CatS p, A arg)
    {
      /* Code For CatS Goes Here */

      p.category_.accept(new CategoryVisitor<R,A>(), arg);

      return null;
    }
    public R visit(CFG.Absyn.TermS p, A arg)
    {
      /* Code For TermS Goes Here */

      //p.string_;

      return null;
    }

  }
  public class NameVisitor<R,A> implements Name.Visitor<R,A>
  {
    public R visit(CFG.Absyn.Name p, A arg)
    {
      /* Code For Name Goes Here */

      for (IdentParam x : p.listidentparam_) {
      }
      p.category_.accept(new CategoryVisitor<R,A>(), arg);

      return null;
    }

  }
  public class CategoryVisitor<R,A> implements Category.Visitor<R,A>
  {
    public R visit(CFG.Absyn.Category p, A arg)
    {
      /* Code For Category Goes Here */

      p.identparam_.accept(new IdentParamVisitor<R,A>(), arg);
      //p.ident_;
      for (Proj x : p.listproj_) {
      }

      return null;
    }

  }
  public class IdentParamVisitor<R,A> implements IdentParam.Visitor<R,A>
  {
    public R visit(CFG.Absyn.IdentParam p, A arg)
    {
      /* Code For IdentParam Goes Here */

      //p.ident_;
      for (Field x : p.listfield_) {
      }

      return null;
    }

  }
  public class FieldVisitor<R,A> implements Field.Visitor<R,A>
  {
    public R visit(CFG.Absyn.Field p, A arg)
    {
      /* Code For Field Goes Here */

      p.keyvalue_.accept(new KeyValueVisitor<R,A>(), arg);

      return null;
    }

  }
  public class ProjVisitor<R,A> implements Proj.Visitor<R,A>
  {
    public R visit(CFG.Absyn.Proj p, A arg)
    {
      /* Code For Proj Goes Here */

      p.param_.accept(new ParamVisitor<R,A>(), arg);

      return null;
    }

  }
  public class KeyValueVisitor<R,A> implements KeyValue.Visitor<R,A>
  {
    public R visit(CFG.Absyn.KeyValue p, A arg)
    {
      /* Code For KeyValue Goes Here */

      //p.ident_;
      p.param_.accept(new ParamVisitor<R,A>(), arg);

      return null;
    }

  }
  public class ParamVisitor<R,A> implements Param.Visitor<R,A>
  {
    public R visit(CFG.Absyn.ParamSimple p, A arg)
    {
      /* Code For ParamSimple Goes Here */

      //p.ident_;

      return null;
    }
    public R visit(CFG.Absyn.ParamPatt p, A arg)
    {
      /* Code For ParamPatt Goes Here */

      //p.ident_1;
      //p.ident_2;

      return null;
    }
    public R visit(CFG.Absyn.ParamRec p, A arg)
    {
      /* Code For ParamRec Goes Here */

      for (KeyValue x : p.listkeyvalue_) {
      }

      return null;
    }

  }
}