package GFC;
import GFC.Absyn.*;

public class PrettyPrinter
{
  //For certain applications increasing the initial size of the buffer may improve performance.
  private static final int INITIAL_BUFFER_SIZE = 128;
  //You may wish to change the parentheses used in precedence.
  private static final String _L_PAREN = new String("(");
  private static final String _R_PAREN = new String(")");
  //You may wish to change render
  private static void render(String s)
  {
    if (s.equals("{"))
    {
       buf_.append("\n");
       indent();
       buf_.append(s);
       _n_ = _n_ + 2;
       buf_.append("\n");
       indent();
    }
    else if (s.equals("(") || s.equals("["))
       buf_.append(s);
    else if (s.equals(")") || s.equals("]"))
    {
       backup();
       buf_.append(s);
       buf_.append(" ");
    }
    else if (s.equals("}"))
    {
       _n_ = _n_ - 2;
       backup();
       backup();
       buf_.append(s);
       buf_.append("\n");
       indent();
    }
    else if (s.equals(","))
    {
       backup();
       buf_.append(s);
       buf_.append(" ");
    }
    else if (s.equals(";"))
    {
       backup();
       buf_.append(s);
       buf_.append("\n");
       indent();
    }
    else if (s.equals("")) return;
    else
    {
       buf_.append(s);
       buf_.append(" ");
    }
  }


  //  print and show methods are defined for each Entry Point type.
  public static String print(GFC.Absyn.Canon foo)
  {
    pp(foo, 0);
    String temp = buf_.toString();
    buf_ = new StringBuffer(INITIAL_BUFFER_SIZE);
    return temp;
  }
  public static String show(GFC.Absyn.Canon foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_ = new StringBuffer(INITIAL_BUFFER_SIZE);
    return temp;
  }
  /***   You shouldn't need to change anything beyond this point.   ***/

  private static void pp(GFC.Absyn.Canon foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.Gr)
    {
       GFC.Absyn.Gr _gr = (GFC.Absyn.Gr) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_gr.listmodule_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.Module foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.Mod)
    {
       GFC.Absyn.Mod _mod = (GFC.Absyn.Mod) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_mod.modtype_, 0);
       render("=");
       pp(_mod.extend_, 0);
       pp(_mod.open_, 0);
       render("{");
       pp(_mod.listflag_, 0);
       pp(_mod.listdef_, 0);
       render("}");
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.ModType foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.MTAbs)
    {
       GFC.Absyn.MTAbs _mtabs = (GFC.Absyn.MTAbs) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("abstract");
       pp(_mtabs.ident_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.MTCnc)
    {
       GFC.Absyn.MTCnc _mtcnc = (GFC.Absyn.MTCnc) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("concrete");
       pp(_mtcnc.ident_1, 0);
       render("of");
       pp(_mtcnc.ident_2, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.MTRes)
    {
       GFC.Absyn.MTRes _mtres = (GFC.Absyn.MTRes) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("resource");
       pp(_mtres.ident_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.MTTrans)
    {
       GFC.Absyn.MTTrans _mttrans = (GFC.Absyn.MTTrans) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("transfer");
       pp(_mttrans.ident_1, 0);
       render(":");
       pp(_mttrans.ident_2, 0);
       render("->");
       pp(_mttrans.ident_3, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.ListModule foo, int _i_)
  {
     for (java.util.Iterator<Module> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render("");
       } else {
         render("");
       }
     }
  }

  private static void pp(GFC.Absyn.Extend foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.Ext)
    {
       GFC.Absyn.Ext _ext = (GFC.Absyn.Ext) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_ext.ident_, 0);
       render("**");
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.NoExt)
    {
       GFC.Absyn.NoExt _noext = (GFC.Absyn.NoExt) foo;
       if (_i_ > 0) render(_L_PAREN);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.Open foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.Opens)
    {
       GFC.Absyn.Opens _opens = (GFC.Absyn.Opens) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("open");
       pp(_opens.listident_, 0);
       render("in");
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.NoOpens)
    {
       GFC.Absyn.NoOpens _noopens = (GFC.Absyn.NoOpens) foo;
       if (_i_ > 0) render(_L_PAREN);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.Flag foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.Flg)
    {
       GFC.Absyn.Flg _flg = (GFC.Absyn.Flg) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("flags");
       pp(_flg.ident_1, 0);
       render("=");
       pp(_flg.ident_2, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.Def foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.AbsDCat)
    {
       GFC.Absyn.AbsDCat _absdcat = (GFC.Absyn.AbsDCat) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("cat");
       pp(_absdcat.ident_, 0);
       render("[");
       pp(_absdcat.listdecl_, 0);
       render("]");
       render("=");
       pp(_absdcat.listcident_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.AbsDFun)
    {
       GFC.Absyn.AbsDFun _absdfun = (GFC.Absyn.AbsDFun) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("fun");
       pp(_absdfun.ident_, 0);
       render(":");
       pp(_absdfun.exp_1, 0);
       render("=");
       pp(_absdfun.exp_2, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.AbsDTrans)
    {
       GFC.Absyn.AbsDTrans _absdtrans = (GFC.Absyn.AbsDTrans) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("transfer");
       pp(_absdtrans.ident_, 0);
       render("=");
       pp(_absdtrans.exp_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.ResDPar)
    {
       GFC.Absyn.ResDPar _resdpar = (GFC.Absyn.ResDPar) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("param");
       pp(_resdpar.ident_, 0);
       render("=");
       pp(_resdpar.listpardef_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.ResDOper)
    {
       GFC.Absyn.ResDOper _resdoper = (GFC.Absyn.ResDOper) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("oper");
       pp(_resdoper.ident_, 0);
       render(":");
       pp(_resdoper.ctype_, 0);
       render("=");
       pp(_resdoper.term_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.CncDCat)
    {
       GFC.Absyn.CncDCat _cncdcat = (GFC.Absyn.CncDCat) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("lincat");
       pp(_cncdcat.ident_, 0);
       render("=");
       pp(_cncdcat.ctype_, 0);
       render("=");
       pp(_cncdcat.term_1, 0);
       render(";");
       pp(_cncdcat.term_2, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.CncDFun)
    {
       GFC.Absyn.CncDFun _cncdfun = (GFC.Absyn.CncDFun) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("lin");
       pp(_cncdfun.ident_, 0);
       render(":");
       pp(_cncdfun.cident_, 0);
       render("=");
       render("\\");
       pp(_cncdfun.listargvar_, 0);
       render("->");
       pp(_cncdfun.term_1, 0);
       render(";");
       pp(_cncdfun.term_2, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.AnyDInd)
    {
       GFC.Absyn.AnyDInd _anydind = (GFC.Absyn.AnyDInd) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_anydind.ident_1, 0);
       pp(_anydind.status_, 0);
       render("in");
       pp(_anydind.ident_2, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.ParDef foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.ParD)
    {
       GFC.Absyn.ParD _pard = (GFC.Absyn.ParD) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_pard.ident_, 0);
       pp(_pard.listctype_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.Status foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.Canon)
    {
       GFC.Absyn.Canon _canon = (GFC.Absyn.Canon) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("data");
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.NonCan)
    {
       GFC.Absyn.NonCan _noncan = (GFC.Absyn.NonCan) foo;
       if (_i_ > 0) render(_L_PAREN);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.CIdent foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.CIQ)
    {
       GFC.Absyn.CIQ _ciq = (GFC.Absyn.CIQ) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_ciq.ident_1, 0);
       render(".");
       pp(_ciq.ident_2, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.Exp foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.EApp)
    {
       GFC.Absyn.EApp _eapp = (GFC.Absyn.EApp) foo;
       if (_i_ > 1) render(_L_PAREN);
       pp(_eapp.exp_1, 1);
       pp(_eapp.exp_2, 2);
       if (_i_ > 1) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.EProd)
    {
       GFC.Absyn.EProd _eprod = (GFC.Absyn.EProd) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("(");
       pp(_eprod.ident_, 0);
       render(":");
       pp(_eprod.exp_1, 0);
       render(")");
       render("->");
       pp(_eprod.exp_2, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.EAbs)
    {
       GFC.Absyn.EAbs _eabs = (GFC.Absyn.EAbs) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("\\");
       pp(_eabs.ident_, 0);
       render("->");
       pp(_eabs.exp_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.EEq)
    {
       GFC.Absyn.EEq _eeq = (GFC.Absyn.EEq) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("{");
       pp(_eeq.listequation_, 0);
       render("}");
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.EAtom)
    {
       GFC.Absyn.EAtom _eatom = (GFC.Absyn.EAtom) foo;
       if (_i_ > 2) render(_L_PAREN);
       pp(_eatom.atom_, 0);
       if (_i_ > 2) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.EData)
    {
       GFC.Absyn.EData _edata = (GFC.Absyn.EData) foo;
       if (_i_ > 2) render(_L_PAREN);
       render("data");
       if (_i_ > 2) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.Sort foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.SType)
    {
       GFC.Absyn.SType _stype = (GFC.Absyn.SType) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("Type");
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.Equation foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.Equ)
    {
       GFC.Absyn.Equ _equ = (GFC.Absyn.Equ) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_equ.listapatt_, 0);
       render("->");
       pp(_equ.exp_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.APatt foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.APC)
    {
       GFC.Absyn.APC _apc = (GFC.Absyn.APC) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("(");
       pp(_apc.cident_, 0);
       pp(_apc.listapatt_, 0);
       render(")");
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.APV)
    {
       GFC.Absyn.APV _apv = (GFC.Absyn.APV) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_apv.ident_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.APS)
    {
       GFC.Absyn.APS _aps = (GFC.Absyn.APS) foo;
       if (_i_ > 0) render(_L_PAREN);
       printQuoted(_aps.string_);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.API)
    {
       GFC.Absyn.API _api = (GFC.Absyn.API) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_api.integer_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.APW)
    {
       GFC.Absyn.APW _apw = (GFC.Absyn.APW) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("_");
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.ListDecl foo, int _i_)
  {
     for (java.util.Iterator<Decl> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render(";");
       } else {
         render("");
       }
     }
  }

  private static void pp(GFC.Absyn.ListAPatt foo, int _i_)
  {
     for (java.util.Iterator<APatt> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render("");
       } else {
         render("");
       }
     }
  }

  private static void pp(GFC.Absyn.ListEquation foo, int _i_)
  {
     for (java.util.Iterator<Equation> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render(";");
       } else {
         render(";");
       }
     }
  }

  private static void pp(GFC.Absyn.Atom foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.AC)
    {
       GFC.Absyn.AC _ac = (GFC.Absyn.AC) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_ac.cident_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.AD)
    {
       GFC.Absyn.AD _ad = (GFC.Absyn.AD) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("<");
       pp(_ad.cident_, 0);
       render(">");
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.AV)
    {
       GFC.Absyn.AV _av = (GFC.Absyn.AV) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("$");
       pp(_av.ident_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.AM)
    {
       GFC.Absyn.AM _am = (GFC.Absyn.AM) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("?");
       pp(_am.integer_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.AS)
    {
       GFC.Absyn.AS _as = (GFC.Absyn.AS) foo;
       if (_i_ > 0) render(_L_PAREN);
       printQuoted(_as.string_);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.AI)
    {
       GFC.Absyn.AI _ai = (GFC.Absyn.AI) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_ai.integer_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.AT)
    {
       GFC.Absyn.AT _at = (GFC.Absyn.AT) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_at.sort_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.Decl foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.Decl)
    {
       GFC.Absyn.Decl _decl = (GFC.Absyn.Decl) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_decl.ident_, 0);
       render(":");
       pp(_decl.exp_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.CType foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.RecType)
    {
       GFC.Absyn.RecType _rectype = (GFC.Absyn.RecType) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("{");
       pp(_rectype.listlabelling_, 0);
       render("}");
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.Table)
    {
       GFC.Absyn.Table _table = (GFC.Absyn.Table) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("(");
       pp(_table.ctype_1, 0);
       render("=>");
       pp(_table.ctype_2, 0);
       render(")");
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.Cn)
    {
       GFC.Absyn.Cn _cn = (GFC.Absyn.Cn) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_cn.cident_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.TStr)
    {
       GFC.Absyn.TStr _tstr = (GFC.Absyn.TStr) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("Str");
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.Labelling foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.Lbg)
    {
       GFC.Absyn.Lbg _lbg = (GFC.Absyn.Lbg) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_lbg.label_, 0);
       render(":");
       pp(_lbg.ctype_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.Term foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.Arg)
    {
       GFC.Absyn.Arg _arg = (GFC.Absyn.Arg) foo;
       if (_i_ > 2) render(_L_PAREN);
       pp(_arg.argvar_, 0);
       if (_i_ > 2) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.I)
    {
       GFC.Absyn.I _i = (GFC.Absyn.I) foo;
       if (_i_ > 2) render(_L_PAREN);
       pp(_i.cident_, 0);
       if (_i_ > 2) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.Con)
    {
       GFC.Absyn.Con _con = (GFC.Absyn.Con) foo;
       if (_i_ > 2) render(_L_PAREN);
       render("<");
       pp(_con.cident_, 0);
       pp(_con.listterm_, 2);
       render(">");
       if (_i_ > 2) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.LI)
    {
       GFC.Absyn.LI _li = (GFC.Absyn.LI) foo;
       if (_i_ > 2) render(_L_PAREN);
       render("$");
       pp(_li.ident_, 0);
       if (_i_ > 2) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.R)
    {
       GFC.Absyn.R _r = (GFC.Absyn.R) foo;
       if (_i_ > 2) render(_L_PAREN);
       render("{");
       pp(_r.listassign_, 0);
       render("}");
       if (_i_ > 2) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.K)
    {
       GFC.Absyn.K _k = (GFC.Absyn.K) foo;
       if (_i_ > 2) render(_L_PAREN);
       pp(_k.tokn_, 0);
       if (_i_ > 2) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.E)
    {
       GFC.Absyn.E _e = (GFC.Absyn.E) foo;
       if (_i_ > 2) render(_L_PAREN);
       render("[");
       render("]");
       if (_i_ > 2) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.P)
    {
       GFC.Absyn.P _p = (GFC.Absyn.P) foo;
       if (_i_ > 1) render(_L_PAREN);
       pp(_p.term_, 2);
       render(".");
       pp(_p.label_, 0);
       if (_i_ > 1) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.T)
    {
       GFC.Absyn.T _t = (GFC.Absyn.T) foo;
       if (_i_ > 1) render(_L_PAREN);
       render("table");
       pp(_t.ctype_, 0);
       render("{");
       pp(_t.listcase_, 0);
       render("}");
       if (_i_ > 1) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.S)
    {
       GFC.Absyn.S _s = (GFC.Absyn.S) foo;
       if (_i_ > 1) render(_L_PAREN);
       pp(_s.term_1, 1);
       render("!");
       pp(_s.term_2, 2);
       if (_i_ > 1) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.FV)
    {
       GFC.Absyn.FV _fv = (GFC.Absyn.FV) foo;
       if (_i_ > 1) render(_L_PAREN);
       render("variants");
       render("{");
       pp(_fv.listterm_, 2);
       render("}");
       if (_i_ > 1) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.C)
    {
       GFC.Absyn.C _c = (GFC.Absyn.C) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_c.term_1, 0);
       render("++");
       pp(_c.term_2, 1);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.Tokn foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.KS)
    {
       GFC.Absyn.KS _ks = (GFC.Absyn.KS) foo;
       if (_i_ > 0) render(_L_PAREN);
       printQuoted(_ks.string_);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.KP)
    {
       GFC.Absyn.KP _kp = (GFC.Absyn.KP) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("[");
       render("pre");
       pp(_kp.liststring_, 0);
       render("{");
       pp(_kp.listvariant_, 0);
       render("}");
       render("]");
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.Assign foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.Ass)
    {
       GFC.Absyn.Ass _ass = (GFC.Absyn.Ass) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_ass.label_, 0);
       render("=");
       pp(_ass.term_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.Case foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.Cas)
    {
       GFC.Absyn.Cas _cas = (GFC.Absyn.Cas) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_cas.listpatt_, 0);
       render("=>");
       pp(_cas.term_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.Variant foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.Var)
    {
       GFC.Absyn.Var _var = (GFC.Absyn.Var) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_var.liststring_1, 0);
       render("/");
       pp(_var.liststring_2, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.Label foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.L)
    {
       GFC.Absyn.L _l = (GFC.Absyn.L) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_l.ident_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.LV)
    {
       GFC.Absyn.LV _lv = (GFC.Absyn.LV) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("$");
       pp(_lv.integer_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.ArgVar foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.A)
    {
       GFC.Absyn.A _a = (GFC.Absyn.A) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_a.ident_, 0);
       render("@");
       pp(_a.integer_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.AB)
    {
       GFC.Absyn.AB _ab = (GFC.Absyn.AB) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_ab.ident_, 0);
       render("+");
       pp(_ab.integer_1, 0);
       render("@");
       pp(_ab.integer_2, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.Patt foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.PC)
    {
       GFC.Absyn.PC _pc = (GFC.Absyn.PC) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("(");
       pp(_pc.cident_, 0);
       pp(_pc.listpatt_, 0);
       render(")");
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.PV)
    {
       GFC.Absyn.PV _pv = (GFC.Absyn.PV) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_pv.ident_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.PW)
    {
       GFC.Absyn.PW _pw = (GFC.Absyn.PW) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("_");
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof GFC.Absyn.PR)
    {
       GFC.Absyn.PR _pr = (GFC.Absyn.PR) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("{");
       pp(_pr.listpattassign_, 0);
       render("}");
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.PattAssign foo, int _i_)
  {
    if (foo instanceof GFC.Absyn.PAss)
    {
       GFC.Absyn.PAss _pass = (GFC.Absyn.PAss) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_pass.label_, 0);
       render("=");
       pp(_pass.patt_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(GFC.Absyn.ListFlag foo, int _i_)
  {
     for (java.util.Iterator<Flag> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render(";");
       } else {
         render(";");
       }
     }
  }

  private static void pp(GFC.Absyn.ListDef foo, int _i_)
  {
     for (java.util.Iterator<Def> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render(";");
       } else {
         render(";");
       }
     }
  }

  private static void pp(GFC.Absyn.ListParDef foo, int _i_)
  {
     for (java.util.Iterator<ParDef> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render("|");
       } else {
         render("");
       }
     }
  }

  private static void pp(GFC.Absyn.ListCType foo, int _i_)
  {
     for (java.util.Iterator<CType> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render("");
       } else {
         render("");
       }
     }
  }

  private static void pp(GFC.Absyn.ListCIdent foo, int _i_)
  {
     for (java.util.Iterator<CIdent> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render("");
       } else {
         render("");
       }
     }
  }

  private static void pp(GFC.Absyn.ListAssign foo, int _i_)
  {
     for (java.util.Iterator<Assign> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render(";");
       } else {
         render("");
       }
     }
  }

  private static void pp(GFC.Absyn.ListArgVar foo, int _i_)
  {
     for (java.util.Iterator<ArgVar> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render(",");
       } else {
         render("");
       }
     }
  }

  private static void pp(GFC.Absyn.ListLabelling foo, int _i_)
  {
     for (java.util.Iterator<Labelling> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render(";");
       } else {
         render("");
       }
     }
  }

  private static void pp(GFC.Absyn.ListCase foo, int _i_)
  {
     for (java.util.Iterator<Case> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render(";");
       } else {
         render("");
       }
     }
  }

  private static void pp(GFC.Absyn.ListTerm foo, int _i_)
  {
     for (java.util.Iterator<Term> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render("");
       } else {
         render("");
       }
     }
  }

  private static void pp(GFC.Absyn.ListString foo, int _i_)
  {
     for (java.util.Iterator<String> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render("");
       } else {
         render("");
       }
     }
  }

  private static void pp(GFC.Absyn.ListVariant foo, int _i_)
  {
     for (java.util.Iterator<Variant> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render(";");
       } else {
         render("");
       }
     }
  }

  private static void pp(GFC.Absyn.ListPattAssign foo, int _i_)
  {
     for (java.util.Iterator<PattAssign> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render(";");
       } else {
         render("");
       }
     }
  }

  private static void pp(GFC.Absyn.ListPatt foo, int _i_)
  {
     for (java.util.Iterator<Patt> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render("");
       } else {
         render("");
       }
     }
  }

  private static void pp(GFC.Absyn.ListIdent foo, int _i_)
  {
     for (java.util.Iterator<String> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render(",");
       } else {
         render("");
       }
     }
  }


  private static void sh(GFC.Absyn.Canon foo)
  {
    if (foo instanceof GFC.Absyn.Gr)
    {
       GFC.Absyn.Gr _gr = (GFC.Absyn.Gr) foo;
       render("(");
       render("Gr");
       render("[");
       sh(_gr.listmodule_);
       render("]");
       render(")");
    }
  }

  private static void sh(GFC.Absyn.Module foo)
  {
    if (foo instanceof GFC.Absyn.Mod)
    {
       GFC.Absyn.Mod _mod = (GFC.Absyn.Mod) foo;
       render("(");
       render("Mod");
       sh(_mod.modtype_);
       sh(_mod.extend_);
       sh(_mod.open_);
       render("[");
       sh(_mod.listflag_);
       render("]");
       render("[");
       sh(_mod.listdef_);
       render("]");
       render(")");
    }
  }

  private static void sh(GFC.Absyn.ModType foo)
  {
    if (foo instanceof GFC.Absyn.MTAbs)
    {
       GFC.Absyn.MTAbs _mtabs = (GFC.Absyn.MTAbs) foo;
       render("(");
       render("MTAbs");
       sh(_mtabs.ident_);
       render(")");
    }
    if (foo instanceof GFC.Absyn.MTCnc)
    {
       GFC.Absyn.MTCnc _mtcnc = (GFC.Absyn.MTCnc) foo;
       render("(");
       render("MTCnc");
       sh(_mtcnc.ident_1);
       sh(_mtcnc.ident_2);
       render(")");
    }
    if (foo instanceof GFC.Absyn.MTRes)
    {
       GFC.Absyn.MTRes _mtres = (GFC.Absyn.MTRes) foo;
       render("(");
       render("MTRes");
       sh(_mtres.ident_);
       render(")");
    }
    if (foo instanceof GFC.Absyn.MTTrans)
    {
       GFC.Absyn.MTTrans _mttrans = (GFC.Absyn.MTTrans) foo;
       render("(");
       render("MTTrans");
       sh(_mttrans.ident_1);
       sh(_mttrans.ident_2);
       sh(_mttrans.ident_3);
       render(")");
    }
  }

  private static void sh(GFC.Absyn.ListModule foo)
  {
     for (java.util.Iterator<Module> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(GFC.Absyn.Extend foo)
  {
    if (foo instanceof GFC.Absyn.Ext)
    {
       GFC.Absyn.Ext _ext = (GFC.Absyn.Ext) foo;
       render("(");
       render("Ext");
       sh(_ext.ident_);
       render(")");
    }
    if (foo instanceof GFC.Absyn.NoExt)
    {
       GFC.Absyn.NoExt _noext = (GFC.Absyn.NoExt) foo;
       render("NoExt");
    }
  }

  private static void sh(GFC.Absyn.Open foo)
  {
    if (foo instanceof GFC.Absyn.Opens)
    {
       GFC.Absyn.Opens _opens = (GFC.Absyn.Opens) foo;
       render("(");
       render("Opens");
       render("[");
       sh(_opens.listident_);
       render("]");
       render(")");
    }
    if (foo instanceof GFC.Absyn.NoOpens)
    {
       GFC.Absyn.NoOpens _noopens = (GFC.Absyn.NoOpens) foo;
       render("NoOpens");
    }
  }

  private static void sh(GFC.Absyn.Flag foo)
  {
    if (foo instanceof GFC.Absyn.Flg)
    {
       GFC.Absyn.Flg _flg = (GFC.Absyn.Flg) foo;
       render("(");
       render("Flg");
       sh(_flg.ident_1);
       sh(_flg.ident_2);
       render(")");
    }
  }

  private static void sh(GFC.Absyn.Def foo)
  {
    if (foo instanceof GFC.Absyn.AbsDCat)
    {
       GFC.Absyn.AbsDCat _absdcat = (GFC.Absyn.AbsDCat) foo;
       render("(");
       render("AbsDCat");
       sh(_absdcat.ident_);
       render("[");
       sh(_absdcat.listdecl_);
       render("]");
       render("[");
       sh(_absdcat.listcident_);
       render("]");
       render(")");
    }
    if (foo instanceof GFC.Absyn.AbsDFun)
    {
       GFC.Absyn.AbsDFun _absdfun = (GFC.Absyn.AbsDFun) foo;
       render("(");
       render("AbsDFun");
       sh(_absdfun.ident_);
       sh(_absdfun.exp_1);
       sh(_absdfun.exp_2);
       render(")");
    }
    if (foo instanceof GFC.Absyn.AbsDTrans)
    {
       GFC.Absyn.AbsDTrans _absdtrans = (GFC.Absyn.AbsDTrans) foo;
       render("(");
       render("AbsDTrans");
       sh(_absdtrans.ident_);
       sh(_absdtrans.exp_);
       render(")");
    }
    if (foo instanceof GFC.Absyn.ResDPar)
    {
       GFC.Absyn.ResDPar _resdpar = (GFC.Absyn.ResDPar) foo;
       render("(");
       render("ResDPar");
       sh(_resdpar.ident_);
       render("[");
       sh(_resdpar.listpardef_);
       render("]");
       render(")");
    }
    if (foo instanceof GFC.Absyn.ResDOper)
    {
       GFC.Absyn.ResDOper _resdoper = (GFC.Absyn.ResDOper) foo;
       render("(");
       render("ResDOper");
       sh(_resdoper.ident_);
       sh(_resdoper.ctype_);
       sh(_resdoper.term_);
       render(")");
    }
    if (foo instanceof GFC.Absyn.CncDCat)
    {
       GFC.Absyn.CncDCat _cncdcat = (GFC.Absyn.CncDCat) foo;
       render("(");
       render("CncDCat");
       sh(_cncdcat.ident_);
       sh(_cncdcat.ctype_);
       sh(_cncdcat.term_1);
       sh(_cncdcat.term_2);
       render(")");
    }
    if (foo instanceof GFC.Absyn.CncDFun)
    {
       GFC.Absyn.CncDFun _cncdfun = (GFC.Absyn.CncDFun) foo;
       render("(");
       render("CncDFun");
       sh(_cncdfun.ident_);
       sh(_cncdfun.cident_);
       render("[");
       sh(_cncdfun.listargvar_);
       render("]");
       sh(_cncdfun.term_1);
       sh(_cncdfun.term_2);
       render(")");
    }
    if (foo instanceof GFC.Absyn.AnyDInd)
    {
       GFC.Absyn.AnyDInd _anydind = (GFC.Absyn.AnyDInd) foo;
       render("(");
       render("AnyDInd");
       sh(_anydind.ident_1);
       sh(_anydind.status_);
       sh(_anydind.ident_2);
       render(")");
    }
  }

  private static void sh(GFC.Absyn.ParDef foo)
  {
    if (foo instanceof GFC.Absyn.ParD)
    {
       GFC.Absyn.ParD _pard = (GFC.Absyn.ParD) foo;
       render("(");
       render("ParD");
       sh(_pard.ident_);
       render("[");
       sh(_pard.listctype_);
       render("]");
       render(")");
    }
  }

  private static void sh(GFC.Absyn.Status foo)
  {
    if (foo instanceof GFC.Absyn.Canon)
    {
       GFC.Absyn.Canon _canon = (GFC.Absyn.Canon) foo;
       render("Canon");
    }
    if (foo instanceof GFC.Absyn.NonCan)
    {
       GFC.Absyn.NonCan _noncan = (GFC.Absyn.NonCan) foo;
       render("NonCan");
    }
  }

  private static void sh(GFC.Absyn.CIdent foo)
  {
    if (foo instanceof GFC.Absyn.CIQ)
    {
       GFC.Absyn.CIQ _ciq = (GFC.Absyn.CIQ) foo;
       render("(");
       render("CIQ");
       sh(_ciq.ident_1);
       sh(_ciq.ident_2);
       render(")");
    }
  }

  private static void sh(GFC.Absyn.Exp foo)
  {
    if (foo instanceof GFC.Absyn.EApp)
    {
       GFC.Absyn.EApp _eapp = (GFC.Absyn.EApp) foo;
       render("(");
       render("EApp");
       sh(_eapp.exp_1);
       sh(_eapp.exp_2);
       render(")");
    }
    if (foo instanceof GFC.Absyn.EProd)
    {
       GFC.Absyn.EProd _eprod = (GFC.Absyn.EProd) foo;
       render("(");
       render("EProd");
       sh(_eprod.ident_);
       sh(_eprod.exp_1);
       sh(_eprod.exp_2);
       render(")");
    }
    if (foo instanceof GFC.Absyn.EAbs)
    {
       GFC.Absyn.EAbs _eabs = (GFC.Absyn.EAbs) foo;
       render("(");
       render("EAbs");
       sh(_eabs.ident_);
       sh(_eabs.exp_);
       render(")");
    }
    if (foo instanceof GFC.Absyn.EEq)
    {
       GFC.Absyn.EEq _eeq = (GFC.Absyn.EEq) foo;
       render("(");
       render("EEq");
       render("[");
       sh(_eeq.listequation_);
       render("]");
       render(")");
    }
    if (foo instanceof GFC.Absyn.EAtom)
    {
       GFC.Absyn.EAtom _eatom = (GFC.Absyn.EAtom) foo;
       render("(");
       render("EAtom");
       sh(_eatom.atom_);
       render(")");
    }
    if (foo instanceof GFC.Absyn.EData)
    {
       GFC.Absyn.EData _edata = (GFC.Absyn.EData) foo;
       render("EData");
    }
  }

  private static void sh(GFC.Absyn.Sort foo)
  {
    if (foo instanceof GFC.Absyn.SType)
    {
       GFC.Absyn.SType _stype = (GFC.Absyn.SType) foo;
       render("SType");
    }
  }

  private static void sh(GFC.Absyn.Equation foo)
  {
    if (foo instanceof GFC.Absyn.Equ)
    {
       GFC.Absyn.Equ _equ = (GFC.Absyn.Equ) foo;
       render("(");
       render("Equ");
       render("[");
       sh(_equ.listapatt_);
       render("]");
       sh(_equ.exp_);
       render(")");
    }
  }

  private static void sh(GFC.Absyn.APatt foo)
  {
    if (foo instanceof GFC.Absyn.APC)
    {
       GFC.Absyn.APC _apc = (GFC.Absyn.APC) foo;
       render("(");
       render("APC");
       sh(_apc.cident_);
       render("[");
       sh(_apc.listapatt_);
       render("]");
       render(")");
    }
    if (foo instanceof GFC.Absyn.APV)
    {
       GFC.Absyn.APV _apv = (GFC.Absyn.APV) foo;
       render("(");
       render("APV");
       sh(_apv.ident_);
       render(")");
    }
    if (foo instanceof GFC.Absyn.APS)
    {
       GFC.Absyn.APS _aps = (GFC.Absyn.APS) foo;
       render("(");
       render("APS");
       sh(_aps.string_);
       render(")");
    }
    if (foo instanceof GFC.Absyn.API)
    {
       GFC.Absyn.API _api = (GFC.Absyn.API) foo;
       render("(");
       render("API");
       sh(_api.integer_);
       render(")");
    }
    if (foo instanceof GFC.Absyn.APW)
    {
       GFC.Absyn.APW _apw = (GFC.Absyn.APW) foo;
       render("APW");
    }
  }

  private static void sh(GFC.Absyn.ListDecl foo)
  {
     for (java.util.Iterator<Decl> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(GFC.Absyn.ListAPatt foo)
  {
     for (java.util.Iterator<APatt> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(GFC.Absyn.ListEquation foo)
  {
     for (java.util.Iterator<Equation> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(GFC.Absyn.Atom foo)
  {
    if (foo instanceof GFC.Absyn.AC)
    {
       GFC.Absyn.AC _ac = (GFC.Absyn.AC) foo;
       render("(");
       render("AC");
       sh(_ac.cident_);
       render(")");
    }
    if (foo instanceof GFC.Absyn.AD)
    {
       GFC.Absyn.AD _ad = (GFC.Absyn.AD) foo;
       render("(");
       render("AD");
       sh(_ad.cident_);
       render(")");
    }
    if (foo instanceof GFC.Absyn.AV)
    {
       GFC.Absyn.AV _av = (GFC.Absyn.AV) foo;
       render("(");
       render("AV");
       sh(_av.ident_);
       render(")");
    }
    if (foo instanceof GFC.Absyn.AM)
    {
       GFC.Absyn.AM _am = (GFC.Absyn.AM) foo;
       render("(");
       render("AM");
       sh(_am.integer_);
       render(")");
    }
    if (foo instanceof GFC.Absyn.AS)
    {
       GFC.Absyn.AS _as = (GFC.Absyn.AS) foo;
       render("(");
       render("AS");
       sh(_as.string_);
       render(")");
    }
    if (foo instanceof GFC.Absyn.AI)
    {
       GFC.Absyn.AI _ai = (GFC.Absyn.AI) foo;
       render("(");
       render("AI");
       sh(_ai.integer_);
       render(")");
    }
    if (foo instanceof GFC.Absyn.AT)
    {
       GFC.Absyn.AT _at = (GFC.Absyn.AT) foo;
       render("(");
       render("AT");
       sh(_at.sort_);
       render(")");
    }
  }

  private static void sh(GFC.Absyn.Decl foo)
  {
    if (foo instanceof GFC.Absyn.Decl)
    {
       GFC.Absyn.Decl _decl = (GFC.Absyn.Decl) foo;
       render("(");
       render("Decl");
       sh(_decl.ident_);
       sh(_decl.exp_);
       render(")");
    }
  }

  private static void sh(GFC.Absyn.CType foo)
  {
    if (foo instanceof GFC.Absyn.RecType)
    {
       GFC.Absyn.RecType _rectype = (GFC.Absyn.RecType) foo;
       render("(");
       render("RecType");
       render("[");
       sh(_rectype.listlabelling_);
       render("]");
       render(")");
    }
    if (foo instanceof GFC.Absyn.Table)
    {
       GFC.Absyn.Table _table = (GFC.Absyn.Table) foo;
       render("(");
       render("Table");
       sh(_table.ctype_1);
       sh(_table.ctype_2);
       render(")");
    }
    if (foo instanceof GFC.Absyn.Cn)
    {
       GFC.Absyn.Cn _cn = (GFC.Absyn.Cn) foo;
       render("(");
       render("Cn");
       sh(_cn.cident_);
       render(")");
    }
    if (foo instanceof GFC.Absyn.TStr)
    {
       GFC.Absyn.TStr _tstr = (GFC.Absyn.TStr) foo;
       render("TStr");
    }
  }

  private static void sh(GFC.Absyn.Labelling foo)
  {
    if (foo instanceof GFC.Absyn.Lbg)
    {
       GFC.Absyn.Lbg _lbg = (GFC.Absyn.Lbg) foo;
       render("(");
       render("Lbg");
       sh(_lbg.label_);
       sh(_lbg.ctype_);
       render(")");
    }
  }

  private static void sh(GFC.Absyn.Term foo)
  {
    if (foo instanceof GFC.Absyn.Arg)
    {
       GFC.Absyn.Arg _arg = (GFC.Absyn.Arg) foo;
       render("(");
       render("Arg");
       sh(_arg.argvar_);
       render(")");
    }
    if (foo instanceof GFC.Absyn.I)
    {
       GFC.Absyn.I _i = (GFC.Absyn.I) foo;
       render("(");
       render("I");
       sh(_i.cident_);
       render(")");
    }
    if (foo instanceof GFC.Absyn.Con)
    {
       GFC.Absyn.Con _con = (GFC.Absyn.Con) foo;
       render("(");
       render("Con");
       sh(_con.cident_);
       render("[");
       sh(_con.listterm_);
       render("]");
       render(")");
    }
    if (foo instanceof GFC.Absyn.LI)
    {
       GFC.Absyn.LI _li = (GFC.Absyn.LI) foo;
       render("(");
       render("LI");
       sh(_li.ident_);
       render(")");
    }
    if (foo instanceof GFC.Absyn.R)
    {
       GFC.Absyn.R _r = (GFC.Absyn.R) foo;
       render("(");
       render("R");
       render("[");
       sh(_r.listassign_);
       render("]");
       render(")");
    }
    if (foo instanceof GFC.Absyn.K)
    {
       GFC.Absyn.K _k = (GFC.Absyn.K) foo;
       render("(");
       render("K");
       sh(_k.tokn_);
       render(")");
    }
    if (foo instanceof GFC.Absyn.E)
    {
       GFC.Absyn.E _e = (GFC.Absyn.E) foo;
       render("E");
    }
    if (foo instanceof GFC.Absyn.P)
    {
       GFC.Absyn.P _p = (GFC.Absyn.P) foo;
       render("(");
       render("P");
       sh(_p.term_);
       sh(_p.label_);
       render(")");
    }
    if (foo instanceof GFC.Absyn.T)
    {
       GFC.Absyn.T _t = (GFC.Absyn.T) foo;
       render("(");
       render("T");
       sh(_t.ctype_);
       render("[");
       sh(_t.listcase_);
       render("]");
       render(")");
    }
    if (foo instanceof GFC.Absyn.S)
    {
       GFC.Absyn.S _s = (GFC.Absyn.S) foo;
       render("(");
       render("S");
       sh(_s.term_1);
       sh(_s.term_2);
       render(")");
    }
    if (foo instanceof GFC.Absyn.FV)
    {
       GFC.Absyn.FV _fv = (GFC.Absyn.FV) foo;
       render("(");
       render("FV");
       render("[");
       sh(_fv.listterm_);
       render("]");
       render(")");
    }
    if (foo instanceof GFC.Absyn.C)
    {
       GFC.Absyn.C _c = (GFC.Absyn.C) foo;
       render("(");
       render("C");
       sh(_c.term_1);
       sh(_c.term_2);
       render(")");
    }
  }

  private static void sh(GFC.Absyn.Tokn foo)
  {
    if (foo instanceof GFC.Absyn.KS)
    {
       GFC.Absyn.KS _ks = (GFC.Absyn.KS) foo;
       render("(");
       render("KS");
       sh(_ks.string_);
       render(")");
    }
    if (foo instanceof GFC.Absyn.KP)
    {
       GFC.Absyn.KP _kp = (GFC.Absyn.KP) foo;
       render("(");
       render("KP");
       render("[");
       sh(_kp.liststring_);
       render("]");
       render("[");
       sh(_kp.listvariant_);
       render("]");
       render(")");
    }
  }

  private static void sh(GFC.Absyn.Assign foo)
  {
    if (foo instanceof GFC.Absyn.Ass)
    {
       GFC.Absyn.Ass _ass = (GFC.Absyn.Ass) foo;
       render("(");
       render("Ass");
       sh(_ass.label_);
       sh(_ass.term_);
       render(")");
    }
  }

  private static void sh(GFC.Absyn.Case foo)
  {
    if (foo instanceof GFC.Absyn.Cas)
    {
       GFC.Absyn.Cas _cas = (GFC.Absyn.Cas) foo;
       render("(");
       render("Cas");
       render("[");
       sh(_cas.listpatt_);
       render("]");
       sh(_cas.term_);
       render(")");
    }
  }

  private static void sh(GFC.Absyn.Variant foo)
  {
    if (foo instanceof GFC.Absyn.Var)
    {
       GFC.Absyn.Var _var = (GFC.Absyn.Var) foo;
       render("(");
       render("Var");
       render("[");
       sh(_var.liststring_1);
       render("]");
       render("[");
       sh(_var.liststring_2);
       render("]");
       render(")");
    }
  }

  private static void sh(GFC.Absyn.Label foo)
  {
    if (foo instanceof GFC.Absyn.L)
    {
       GFC.Absyn.L _l = (GFC.Absyn.L) foo;
       render("(");
       render("L");
       sh(_l.ident_);
       render(")");
    }
    if (foo instanceof GFC.Absyn.LV)
    {
       GFC.Absyn.LV _lv = (GFC.Absyn.LV) foo;
       render("(");
       render("LV");
       sh(_lv.integer_);
       render(")");
    }
  }

  private static void sh(GFC.Absyn.ArgVar foo)
  {
    if (foo instanceof GFC.Absyn.A)
    {
       GFC.Absyn.A _a = (GFC.Absyn.A) foo;
       render("(");
       render("A");
       sh(_a.ident_);
       sh(_a.integer_);
       render(")");
    }
    if (foo instanceof GFC.Absyn.AB)
    {
       GFC.Absyn.AB _ab = (GFC.Absyn.AB) foo;
       render("(");
       render("AB");
       sh(_ab.ident_);
       sh(_ab.integer_1);
       sh(_ab.integer_2);
       render(")");
    }
  }

  private static void sh(GFC.Absyn.Patt foo)
  {
    if (foo instanceof GFC.Absyn.PC)
    {
       GFC.Absyn.PC _pc = (GFC.Absyn.PC) foo;
       render("(");
       render("PC");
       sh(_pc.cident_);
       render("[");
       sh(_pc.listpatt_);
       render("]");
       render(")");
    }
    if (foo instanceof GFC.Absyn.PV)
    {
       GFC.Absyn.PV _pv = (GFC.Absyn.PV) foo;
       render("(");
       render("PV");
       sh(_pv.ident_);
       render(")");
    }
    if (foo instanceof GFC.Absyn.PW)
    {
       GFC.Absyn.PW _pw = (GFC.Absyn.PW) foo;
       render("PW");
    }
    if (foo instanceof GFC.Absyn.PR)
    {
       GFC.Absyn.PR _pr = (GFC.Absyn.PR) foo;
       render("(");
       render("PR");
       render("[");
       sh(_pr.listpattassign_);
       render("]");
       render(")");
    }
  }

  private static void sh(GFC.Absyn.PattAssign foo)
  {
    if (foo instanceof GFC.Absyn.PAss)
    {
       GFC.Absyn.PAss _pass = (GFC.Absyn.PAss) foo;
       render("(");
       render("PAss");
       sh(_pass.label_);
       sh(_pass.patt_);
       render(")");
    }
  }

  private static void sh(GFC.Absyn.ListFlag foo)
  {
     for (java.util.Iterator<Flag> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(GFC.Absyn.ListDef foo)
  {
     for (java.util.Iterator<Def> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(GFC.Absyn.ListParDef foo)
  {
     for (java.util.Iterator<ParDef> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(GFC.Absyn.ListCType foo)
  {
     for (java.util.Iterator<CType> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(GFC.Absyn.ListCIdent foo)
  {
     for (java.util.Iterator<CIdent> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(GFC.Absyn.ListAssign foo)
  {
     for (java.util.Iterator<Assign> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(GFC.Absyn.ListArgVar foo)
  {
     for (java.util.Iterator<ArgVar> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(GFC.Absyn.ListLabelling foo)
  {
     for (java.util.Iterator<Labelling> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(GFC.Absyn.ListCase foo)
  {
     for (java.util.Iterator<Case> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(GFC.Absyn.ListTerm foo)
  {
     for (java.util.Iterator<Term> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(GFC.Absyn.ListString foo)
  {
     for (java.util.Iterator<String> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(GFC.Absyn.ListVariant foo)
  {
     for (java.util.Iterator<Variant> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(GFC.Absyn.ListPattAssign foo)
  {
     for (java.util.Iterator<PattAssign> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(GFC.Absyn.ListPatt foo)
  {
     for (java.util.Iterator<Patt> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(GFC.Absyn.ListIdent foo)
  {
     for (java.util.Iterator<String> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }


  private static void pp(Integer n, int _i_) { buf_.append(n); buf_.append(" "); }
  private static void pp(Double d, int _i_) { buf_.append(d); buf_.append(" "); }
  private static void pp(String s, int _i_) { buf_.append(s); buf_.append(" "); }
  private static void pp(Character c, int _i_) { buf_.append("'" + c.toString() + "'"); buf_.append(" "); }
  private static void sh(Integer n) { buf_.append(n); }
  private static void sh(Double d) { buf_.append(d); }
  private static void sh(Character c) { buf_.append(c); }
  private static void sh(String s) { printQuoted(s); }
  private static void printQuoted(String s) { buf_.append("\"" + s + "\""); }
  private static void indent()
  {
    int n = _n_;
    while (n > 0)
    {
      buf_.append(" ");
      n--;
    }
  }
  private static void backup()
  {
   String s = buf_.toString();

     if (s.substring(buf_.length() - 1, buf_.length()).equals(" ")) {
       buf_.setCharAt(buf_.length() - 1, '\"');
       buf_.setLength(buf_.length() - 1);
     }
  }
  private static int _n_ = 0;
  private static StringBuffer buf_ = new StringBuffer(INITIAL_BUFFER_SIZE);
}

