package linearize;

import abssyn.Tree;
import linearize.gfvalue.Value;

/** 
 *  Interface implemented by all linearizers.
 */
public interface Linearizer {

        /**
         *  Linearize the given abstract syntax tree to a GF value.
         *  NOTE: the tree should be annotated before calling this function.
         */ 
        public Value linearize(Tree t);

        /**
         *  Get the name of this linearizer.
         */
        public String getName();

        /**
         *  Whether this linearizer should be used when linearizing with all
         *  available linearizers.
         */
        public boolean tryThisOne();

}
