package linearize;

import abssyn.*;
import gfcutil.*;

/**
 *  Does type annotation of abstract syntax trees.
 */
public class TypeAnnotator {

        private GFCModule module;

        /**
         *  @param module Abstract module used to get types of functions.
         */
        public TypeAnnotator(GFCModule module) {
                this.module = module;
        }

        /**
         *  Type-annotate all meta-variables in the given tree.
         */
        public void annotate(Tree t) {
                String startcat = null; //FIXME: figure out startcat
                t.accept(new Annotator(), startcat);
        }

        private class Annotator implements TreeVisitor<Tree,String> {
                public Tree visit(Fun f, String type) {
                        Function fun = module.findFunction(f.getLabel());

                        assert fun.getArgCats().size() == f.countChildren();

                        System.err.println(fun);

                        int i = 0;
                        for (String t : fun.getArgCats())
                                f.getChild(i++).accept(this, t);
                        return f;
                }

                public Tree visit(Literal l, String type) {
                        return l;
                }

                public Tree visit(MetaVariable v, String type) {
                        v.setType(type);
                        return v;
                }
        }

}
