package linearize.gfvalue;

import util.PrefixMap;
import util.Pair;

import java.util.List;

public class Pre extends Value {

        private PrefixMap<Value> map;

        public Pre(Value def, List<Pair<Value,List<String>>> vs) {
                if (def == null)
                        throw new RuntimeException("No default value for prefix-dependent rule.");

                map = new PrefixMap<Value>();
                map.put("", def);
                for (Pair<Value,List<String>> p : vs) {
                        Value v = p.fst;
                        for (String s : p.snd) {
                                map.put(s, v);
                        }
                }
        }

        public String linearize(String next) {
                return map.get(next).linearize(next);
        }

        public String toString() {
                // FIXME: is it right to alway show the default here?
                return map.get("").toString();
        }

}
