package linearize.gfvalue;

import java.util.*;

public class Record extends Value {

        private Map<String,Value> fields;

        public Record() {
                this.fields = new TreeMap<String,Value>();
        }

        public Value get(String name) {
                Value v = fields.get(name);
                if (v == null)
                        throw new RuntimeException("Field " + v + " does not exit in " + this);
                return v;
        }

        public void set(String name, Value value) {
                fields.put(name, value);
        }

        public int hashCode() {
                return toString().hashCode();
        }

        public boolean equals(Object o) {
                return (o instanceof Record) && equals((Record)o);
        }

        public boolean equals(Record r) {
                return fields.equals(r.fields);
        }

        public String toString() {
                StringBuilder sb = new StringBuilder("{");
                for (Map.Entry e : fields.entrySet()) {
                        sb.append(e.getKey());
                        sb.append(" = ");
                        sb.append(e.getValue());
                        sb.append(", ");
                }
                // hack, delete final comma
                if (!fields.isEmpty()) {
                        int n = sb.length();
                        sb.delete(n-2,n);
                }
                sb.append("}");
                return sb.toString();
        }

        public static Record ss(String s) {
                Record r = new Record();
                r.set("s", new Str(s));
                return r;
        }

}
