package parse;

import abssyn.*;
import SyntaxTree.TreeParser;

import java.util.*;

/**
 *  Parse a the parenthesized pre-order representation of abstract syntax
 *  use in GF.
 */
public class ParseTree implements Parser {
        public List<Tree> parse(String s) {
                try {
                        Tree t = GFTreeToTree.toTree(TreeParser.parseTree(s));
                        return Arrays.asList(t);
                } catch (RuntimeException ex) {
                        //System.err.println(ex);
                        return new LinkedList<Tree>();
                }
        }

        public List<Tree> parse(String s, String cat) {
                if (!cat.equals("Tree"))
                        throw new RuntimeException("Unsupported category " + cat);

                return parse(s);
        }

        public String getName() {
                return "tree";
        }

        public boolean tryThisOne() {
                return false;
        }

}
