package parse;

import java.util.*;

public class Parsers {

        protected Map<String,Parser> map;

        public Parsers() {
                map = new TreeMap<String,Parser>();
        }

        public Parser getParser(String lang) {
                Parser parser = map.get(lang);

                if (parser == null) 
                        throw new RuntimeException("There is no parser for " + lang);

                return parser;
        }

        public void addParser(Parser parser) {
                String lang = parser.getName();
                if (map.containsKey(lang)) 
                        throw new RuntimeException("There is already a parser for " + lang);
                map.put(lang, parser);
        }

        public Set<String> listParsers() {
                return map.keySet();
        }

}
