package parse.chart;

import parse.Parsers;

import java.io.*;

public class CFGParsers extends Parsers {

        public CFGParsers(CFGGrammars grammars) {
                for (String n : grammars.listGrammars()) {
                        System.err.println("Loading cfg grammar " + n);
                        CFGrammar g = grammars.getGrammar(n);
                        ChartParser p = new ChartParser(g);
                        addParser(p);
                }
        }

        public static CFGParsers readParsers(Reader in) throws IOException {
                return new CFGParsers(CFGGrammars.readCFGM(in));
        }

        public static CFGParsers readParsers(String file) throws IOException {
                return new CFGParsers(CFGGrammars.readCFGM(file));
        }

}
