package parse.chart;

import java.util.*;

public class TerminalRule extends Rule {

        private Terminal terminal;

        public TerminalRule(String name, Category cat, Terminal terminal) {
                super(name, cat);
                this.terminal = terminal;
        }

        public boolean matches(Token token) {
                return terminal.matches(token);
        }

        public String getFun() {
                return getName(); // FIXME: should we really use name here?
        }

        public int getSize() {
                return 1;
        }

        public boolean isTerminal() {
                return true;
        }

        public String toString() {
                StringBuilder sb = new StringBuilder();
                sb.append(getName());
                sb.append(". ");
                sb.append(getCategory());
                sb.append(" -> ");
                sb.append(terminal);

                return sb.toString();
        }

}
