package util;

import java.util.*;

public class PrefixMap<A> {

        private A value;

        private Map<Character,PrefixMap<A>> map;

        public PrefixMap() {
                value = null;
                map = new HashMap<Character,PrefixMap<A>>();
        }
        
        public A put (String key, A newvalue) {
                if (key.length() == 0) {
                        A old = value;
                        value = newvalue;
                        return old;
                } else {
                        Character head = key.charAt(0);
                        // FIXME: inefficient
                        String tail = key.substring(1);

                        PrefixMap<A> m = map.get(head);
                        if (m == null) {
                                m = new PrefixMap<A>();
                                map.put(head, m);
                        }
                        return m.put(tail, newvalue);
                }
        }

        public A get (String key) {
                if (key.length() == 0)
                        return value;
                Character head = key.charAt(0);
                // FIXME: inefficient
                String tail = key.substring(1);
                PrefixMap<A> m = map.get(head);
                if (m == null)
                        return value;

                A v = m.get(tail);
                if (v == null)
                        return value;

                return v;
        }

}
